###################################################
### chunk number 1: 
###################################################
#line 54 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
op <- options(width = 80, digits = 2, scipen = 5)


###################################################
### chunk number 2: 
###################################################
#line 73 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
library(portfolio)


###################################################
### chunk number 3: 
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
data(assay)
assay[c(1407, 1873, 1058, 2453, 1833, 1390), c("id", "symbol", "name", "country", 
  "currency", "price", "sector", "liq", "on.fl", "ret.0.3.m", "ret.0.6.m")]


###################################################
### chunk number 4: creating assay portfolio
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
assay$assay.wt <- ifelse(assay$on.fl, -1, NA)
p <- new("portfolioBasic",
         name    = "AFL Portfolio",
         instant = as.Date("2004-12-31"),
         data    = assay,
         id.var  = "symbol",
         in.var  = "assay.wt",
         type    = "relative",
         size    = "all",
         ret.var = "ret.0.3.m")
summary(p)
summary(performance(p))


###################################################
### chunk number 5: measuring sector exposure
###################################################
#line 188 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
exposure(p, exp.var = 'sector')


###################################################
### chunk number 6: 
###################################################
#line 319 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
p.m <- matching(p, covariates = c("country", "sector", "liq"))


###################################################
### chunk number 7: 
###################################################
#line 322 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
summary(p.m)


###################################################
### chunk number 8: test all
###################################################
#line 329 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
all(!p.m@matches[,1] %in% p@weights$id)


###################################################
### chunk number 9: 
###################################################
#line 341 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
exposure(p, exp.var = "sector")
exposure(p.m, exp.var = "sector")


###################################################
### chunk number 10: 
###################################################
#line 351 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
exposure(p, exp.var = "liq")


###################################################
### chunk number 11: 
###################################################
#line 357 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
exposure(p.m, exp.var = "liq")


###################################################
### chunk number 12: 
###################################################
#line 379 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
summary(performance(p.m))


###################################################
### chunk number 13: 
###################################################
#line 412 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/matching_portfolio.Rnw"
options(op)


