###################################################
### chunk number 1: 
###################################################
#line 41 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
## Sets display options
options(width = 75, digits = 2, scipen = 5)
set.seed(0)
## Loads the package 
library(portfolio) 


###################################################
### chunk number 2: 
###################################################
#line 49 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
## data saved for this example

## save(portfolios, misc, data.list, mvCandidates, file = "tradelist.RData", compress = TRUE)

## loads the dataset for this vignette

load("tradelist.RData")

p.current <- portfolios[["p.current.abs"]]
p.target <- portfolios[["p.target.abs"]]
data <- data.list[["data.abs"]]

sorts <- list(alpha = 1.5, ret.1.d = 1)

tl <- new("tradelist", orig = p.current, target = p.target, sorts =
sorts, turnover = 2000, chunk.usd = 2000, data = data, to.equity = FALSE)



###################################################
### chunk number 3: p.current@shares
###################################################
#line 208 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.current@shares[, c("shares", "price")]


###################################################
### chunk number 4: p.target@shares
###################################################
#line 220 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.target@shares[, c("shares", "price")]


###################################################
### chunk number 5: 
###################################################
#line 253 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@candidates[, c("side", "shares", "mv")]


###################################################
### chunk number 6: shows alpha sort
###################################################
#line 311 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp <- data.frame(side = tl@candidates[, "side"], alpha =  tl@ranks[, "alpha"])
row.names(tmp) <- tl@candidates$id
tmp  <- tmp[order(tmp$alpha, decreasing = TRUE),]
tmp


###################################################
### chunk number 7: trades ranked and ordered by alpha
###################################################
#line 344 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## for buys, ranks by the inverse because lower values are better
tl@ranks$rank <- rank(-tl@ranks$alpha, na.last = TRUE,  ties.method = "random")

## removes the "ret.1.d" column for successful row binding later on
alpha <- tl@ranks[,!names(tl@ranks) %in% "ret.1.d"]

## appends a column so we know what sort these values come from
alpha$sort <- "alpha"

alpha[order(alpha$rank), c("rank", "side", "alpha", "shares", "mv")]


###################################################
### chunk number 8: ret.1.d sort
###################################################
#line 395 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp <- tl@ranks[order(tl@ranks$ret.1.d), c("side","ret.1.d")]
tmp <- cbind(rank = 1:nrow(tmp), tmp)
tmp$ret.1.d <- tmp$ret.1.d[order(tmp$ret.1.d, decreasing = TRUE)]
row.names(tmp) <- tl@candidates$id


###################################################
### chunk number 9: two sorts sorting by alpha
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp.1 <- tl@ranks[order(tl@ranks$alpha, decreasing = TRUE), c("alpha", "ret.1.d")]
tmp.1 <- tmp.1 <- cbind(rank = 1:nrow(tmp.1), tmp.1)
tmp.1


###################################################
### chunk number 10: two sorts sorting by ret.1.d
###################################################
#line 419 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp.2 <- tl@ranks[order(tl@ranks$ret.1.d, decreasing = TRUE), c("alpha", "ret.1.d")]
tmp.2 <- cbind(rank = 1:nrow(tmp.2), tmp.2)
tmp.2


###################################################
### chunk number 11: trades ranked and ordered by ret.1.d
###################################################
#line 434 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
## we don't actually show any of these values right here
## for buys, ranks by the inverse because lower values are better
tl@ranks$rank <- rank(-tl@ranks$ret.1.d, na.last = TRUE, ties.method = "random")
## removes the "alpha" column for successful row binding later on
ret.1.d <- tl@ranks[,!names(tl@ranks) %in% "alpha"]
## appends a column so we know what sort these values come from
ret.1.d$sort <- "ret.1.d"


###################################################
### chunk number 12: weighted alpha
###################################################
#line 475 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
## saves off alpha$rank
alpha.rank.orig <- alpha$rank

alpha$rank <- alpha$rank
alpha[order(alpha$rank), c("rank", "side", "alpha", "shares", "mv")]


###################################################
### chunk number 13: unweighted ret.1.d
###################################################
#line 486 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
ret.1.d[order(ret.1.d$rank), c("rank", "side", "ret.1.d", "shares", "mv")]


###################################################
### chunk number 14: unweighted ranks
###################################################
#line 508 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## sets the ranks of alpha to the original, unweighted ranks
alpha$rank <- alpha.rank.orig

## subsets out the "alpha" and "ret.1.d" columns so that both data frames have the same set of columns
alpha   <- alpha[,!names(alpha) %in% "alpha"]
ret.1.d <- ret.1.d[,!names(ret.1.d) %in% "ret.1.d"]

overall.ranks <- rbind(alpha, ret.1.d)
overall.ranks <- overall.ranks[order(overall.ranks$rank), c("id", "sort", "rank", "side", "shares", "mv")]
row.names(overall.ranks) <- paste(overall.ranks$id, overall.ranks$sort, sep = ".")
overall.ranks[, c("rank", "sort", "side", "shares", "mv")]


###################################################
### chunk number 15: unweighted w/out duplicates
###################################################
#line 537 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

ranks <- alpha
top.ranks <- aggregate(overall.ranks[c("rank")], by = list(id = overall.ranks$id), min)
ranks$rank <- top.ranks$rank[match(ranks$id, top.ranks$id)]
ranks[order(ranks$rank), c("rank", "shares", "mv")]


###################################################
### chunk number 16: unbalanced weights
###################################################
#line 564 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
## Assigns one sort, alpha, a much higher weight than the other sort

## restores the original alpha rankings

alpha$rank <- alpha.rank.orig

## weights the alpha rankings by 10

alpha$rank <- alpha$rank / 10

overall.ranks <- data.frame()
overall.ranks <- rbind(alpha, ret.1.d)
overall.ranks <- overall.ranks[order(overall.ranks$rank), c("id", "sort", "rank", "side", "shares", "mv")]
row.names(overall.ranks) <- paste(overall.ranks$id, overall.ranks$sort, sep = ".")
overall.ranks[c("rank", "side", "shares", "mv")]


###################################################
### chunk number 17: unbalanced w/out duplicates
###################################################
#line 587 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

top.ranks <- do.call(rbind, lapply(split(overall.ranks, overall.ranks$id),
                                   function(x) { x[which.min(x$rank),] }))
top.ranks <- top.ranks[order(top.ranks$rank),]
top.ranks[c("rank","sort","shares","mv")]

ranks <- alpha
top.ranks <- aggregate(overall.ranks[c("rank")], by = list(id = overall.ranks$id), min)
ranks$rank <- top.ranks$rank[match(ranks$id, top.ranks$id)]
## ranks[order(ranks$rank), c("rank", "sort", "shares", "mv")]


###################################################
### chunk number 18: mixed weighting
###################################################
#line 610 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## returns alpha$rank to original level

alpha$rank <- alpha.rank.orig
alpha$rank <- alpha$rank / 1.5

overall.ranks <- data.frame()
overall.ranks <- rbind(alpha, ret.1.d)
overall.ranks <- overall.ranks[order(overall.ranks$rank), c("id", "sort", "rank", "side", "shares", "mv")]
row.names(overall.ranks) <- paste(overall.ranks$id, overall.ranks$sort, sep = ".")
overall.ranks[c("rank", "side", "shares", "mv")]


###################################################
### chunk number 19: mixed w/out duplicates
###################################################
#line 627 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

top.ranks <- do.call(rbind, lapply(split(overall.ranks, overall.ranks$id),
                                   function(x) { x[which.min(x$rank),] }))
top.ranks <- top.ranks[order(top.ranks$rank),]
top.ranks[c("rank","sort","shares","mv")]

ranks <- alpha
top.ranks <- aggregate(overall.ranks[c("rank")], by = list(id = overall.ranks$id), min)
ranks$rank <- top.ranks$rank[match(ranks$id, top.ranks$id)]
tmp <- ranks[order(ranks$rank), c("rank", "sort", "shares", "mv")]
## tmp


###################################################
### chunk number 20: 
###################################################
#line 681 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp$rank <- rank(tmp$rank, ties.method = "first")
tmp[order(tmp$rank),c("rank","shares","mv")]


###################################################
### chunk number 21: scaling ranks
###################################################
#line 690 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## a hacked version of the scaling function in calcRanks, built only
## for a list of all buys

r.max  <- max(tmp$rank) + 1
r.mult <- 0.15
r.add  <- 0.85

tmp$rank.s <- (r.mult * tmp$rank[nrow(tmp):1] / r.max) + r.add

## Saves off rank.s for later use
rank.s <- tmp

tmp[c("rank","shares","mv","rank.s")]


###################################################
### chunk number 22: synthesised ranks
###################################################
#line 712 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp$rank.t <- qnorm(tmp$rank.s)
tmp[c("rank", "shares", "mv","rank.s", "rank.t")]


###################################################
### chunk number 23: chunk w/out tca.rank
###################################################
#line 833 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@chunks[order(-tl@chunks$rank.t), c("side", "shares", "mv", "alpha", "ret.1.d", "rank.t", "chunk.shares", "chunk.mv")]


###################################################
### chunk number 24: trading volume
###################################################
#line 864 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
trading.volume <- data.frame(rank.t = tl@ranks$rank.t, volume = tl@data$volume[match(tl@ranks$id, tl@data$id)], shares = tl@ranks$shares)
row.names(trading.volume) <- tl@ranks$id
trading.volume[order(-trading.volume$rank.t),]


###################################################
### chunk number 25: chunks w/ tca.rank
###################################################
#line 894 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl@chunks[order(-tl@chunks$rank.t), c("side", "mv", "alpha", "ret.1.d",
                                      "rank.t", "chunk.shares", "chunk.mv", "tca.rank")]


###################################################
### chunk number 26: ordered chunks w/ tca.rank
###################################################
#line 908 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl@chunks[order(tl@chunks$tca.rank, decreasing = TRUE), c("side",
              "mv", "alpha", "ret.1.d", "rank.t", "chunk.shares",
              "chunk.mv", "tca.rank")]


###################################################
### chunk number 27: rank.s
###################################################
#line 936 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
rank.s[c("rank","shares","mv","rank.s")]


###################################################
### chunk number 28: rank.t
###################################################
#line 945 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
rank.t <- rank.s
rank.t$rank.t <- qnorm(rank.t$rank.s)
rank.t[c("rank","shares","mv","rank.s","rank.t")]


###################################################
### chunk number 29: misc$rank.s
###################################################
#line 968 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
misc$rank.s


###################################################
### chunk number 30: swaps table
###################################################
#line 1163 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
head(tl@swaps[, c("tca.rank.enter", "tca.rank.exit",
"rank.gain")])


###################################################
### chunk number 31: 
###################################################
#line 1240 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@swaps.actual[, c("tca.rank.enter", "tca.rank.exit",
"rank.gain")]


###################################################
### chunk number 32: remove idiots
###################################################
#line 1257 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl@chunks.actual[, c("side", "mv", "alpha", "ret.1.d", "rank.t",
              "chunk.shares", "chunk.mv", "tca.rank")]


###################################################
### chunk number 33: 
###################################################
#line 1265 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@actual[, !names(tl@actual) %in% c("id")]


###################################################
### chunk number 34: 
###################################################
#line 2329 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## Clears the search list.

rm(list = ls())
load("tradelist.RData")

## prepares data for this example

p.current <- portfolios[["p.current.lo"]]
p.target <- portfolios[["p.target.lo"]]
data <- data.list[["data.lo"]]

## Original Equity, Target Equity

oe <- portfolio:::mvShort(p.current) + portfolio:::mvLong(p.current)
te <- portfolio:::mvShort(p.target) + portfolio:::mvLong(p.target)

## Creates the sorts list

sorts <- list(alpha = 1, ret.1.d = 1.1)

## Creates the tradelist so we can use different measures

tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2000, sorts = sorts, turnover = 30250, target.equity = te, data =
data)

## Necessary turnover to make all the candidate trades

nt <- mvCandidates(tl)



###################################################
### chunk number 35: prep-p.current.shares
###################################################
#line 2375 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.current.shares <- p.current@shares[, c("shares", "price")]


###################################################
### chunk number 36: p.current.shares
###################################################
#line 2379 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.current.shares


###################################################
### chunk number 37: 
###################################################
#line 2387 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.target.shares <- p.target@shares[, c("shares", "price")]


###################################################
### chunk number 38: 
###################################################
#line 2391 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.target.shares


###################################################
### chunk number 39: 
###################################################
#line 2401 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.candidates <- tl@candidates[,!names(tl@candidates) %in% "id"]


###################################################
### chunk number 40: long-only candidates
###################################################
#line 2405 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.candidates


###################################################
### chunk number 41: 
###################################################
#line 2417 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sorts <- list(alpha = 1, ret.1.d = 1.1)


###################################################
### chunk number 42: 
###################################################
#line 2431 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
row.names(data) <- data$id
sub.data <- data[, c("id", "volume", "price.usd", "alpha", "ret.1.d")]


###################################################
### chunk number 43: necessary data
###################################################
#line 2436 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.data


###################################################
### chunk number 44: new long-only tl
###################################################
#line 2451 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2000, sorts = sorts, turnover = 30250, data = data)



###################################################
### chunk number 45: 
###################################################
#line 2458 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2000, sorts = sorts, turnover = 30250, target.equity = 47500, data =
data)



###################################################
### chunk number 46: tl@candidates
###################################################
#line 2529 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@candidates


###################################################
### chunk number 47: 
###################################################
#line 2569 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

ranks <- tl@rank.sorts$ret.1.d
ranks <- split(ranks, ranks$side)
ranks$B$rank <- 1:nrow(ranks$B)
ranks$S$rank <- 1:nrow(ranks$S)
ranks



###################################################
### chunk number 48: 
###################################################
#line 2601 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp <- rbind(ranks$B, ranks$S)[order(rbind(ranks$B, ranks$S)[["rank"]]),]
tmp[,!names(tmp) %in% "id"]


###################################################
### chunk number 49: 
###################################################
#line 2612 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@rank.sorts[["alpha"]][,!names(tl@rank.sorts[["alpha"]]) %in% "id"]


###################################################
### chunk number 50: lo weighted ranks
###################################################
#line 2640 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
ranks <- tl@rank.sorts[["ret.1.d"]]
ranks[["rank"]] <- ranks[["rank"]]/sorts[["ret.1.d"]]
ranks


###################################################
### chunk number 51: 
###################################################
#line 2648 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@rank.sorts[["alpha"]]


###################################################
### chunk number 52: prep-duplicates
###################################################
#line 2655 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

alpha <- tl@rank.sorts[["alpha"]]
ret.1.d <- tl@rank.sorts[["ret.1.d"]]

alpha <- alpha[,!names(alpha) %in% "alpha"]
ret.1.d <- ret.1.d[,!names(ret.1.d) %in% "ret.1.d"]

duplicates <- rbind(alpha, ret.1.d)
duplicates <- duplicates[order(duplicates$id),]
row.names(duplicates) <- 1:nrow(duplicates)



###################################################
### chunk number 53: duplicates
###################################################
#line 2669 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
duplicates


###################################################
### chunk number 54: prep-top.ranks
###################################################
#line 2676 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks <- tl@ranks


###################################################
### chunk number 55: top.ranks
###################################################
#line 2680 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
top.ranks <- aggregate(duplicates[c("rank")], by = list(id = duplicates$id), min)
tl.ranks$rank <- top.ranks$rank[match(tl.ranks$id, top.ranks$id)]
tl.ranks[order(tl.ranks$rank), !names(tl@ranks) %in% c("id", "alpha", "ret.1.d", "rank.t")]


###################################################
### chunk number 56: 
###################################################
#line 2688 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl.ranks$rank <- rank(tl.ranks$rank)
tl.ranks <- tl.ranks[, !names(tl.ranks) %in% c("id", "alpha", "ret.1.d")]

tl.ranks[order(tl.ranks$rank), !names(tl@ranks) %in% c("id", "alpha", "ret.1.d", "rank.t")]


###################################################
### chunk number 57: scaled.ranks.lo
###################################################
#line 2705 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
misc$scaled.ranks.lo


###################################################
### chunk number 58: pre.rank.t
###################################################
#line 2711 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks <- tl@ranks[order(tl@ranks$rank.t),!names(tl.ranks) %in% "id"]


###################################################
### chunk number 59: rank.t
###################################################
#line 2715 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks


###################################################
### chunk number 60: prep-chunks
###################################################
#line 2737 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks <- tl@chunks[, c("side", "rank.t", "chunk.shares",
                           "chunk.mv", "tca.rank")]


###################################################
### chunk number 61: chunks
###################################################
#line 2742 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks


###################################################
### chunk number 62: ordered chunks
###################################################
#line 2759 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
head(sub.chunks[order(sub.chunks[["tca.rank"]]),])


###################################################
### chunk number 63: prep-swaps
###################################################
#line 2787 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
swaps.sub <- tl@swaps[, c("side.enter", "tca.rank.enter", "side.exit", "tca.rank.exit",
"rank.gain")]


###################################################
### chunk number 64: 
###################################################
#line 2792 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
swaps.sub


###################################################
### chunk number 65: prep-swaps.actual
###################################################
#line 2822 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

sub.swaps.actual <- tl@swaps.actual[, c("side.enter", "tca.rank.enter", "side.exit", "tca.rank.exit",
"rank.gain")]



###################################################
### chunk number 66: swaps.actual
###################################################
#line 2829 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual


###################################################
### chunk number 67: pre-turnover.text
###################################################
#line 2840 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.bak <- tl


###################################################
### chunk number 68: 
###################################################
#line 2844 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@turnover <- 30250 - tl@chunk.usd


###################################################
### chunk number 69: 
###################################################
#line 2848 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl <- portfolio:::calcSwapsActual(tl)
sub.swaps.actual <- tl@swaps.actual[, c("side.enter", "tca.rank.enter", "side.exit", "tca.rank.exit",
"rank.gain")]



###################################################
### chunk number 70: sub.swaps.actual
###################################################
#line 2861 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual


###################################################
### chunk number 71: restores tl
###################################################
#line 2865 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl <- tl.bak


###################################################
### chunk number 72: 
###################################################
#line 2879 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks.actual <- tl@chunks.actual[,!names(tl@chunks.actual)
%in% c("id", "orig", "target", "shares", "mv")]


###################################################
### chunk number 73: sub.chunks.actual
###################################################
#line 2884 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks.actual


###################################################
### chunk number 74: prep-tl.actual
###################################################
#line 2895 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.actual <- tl@actual[, !names(tl@actual) %in% c("id")]


###################################################
### chunk number 75: tl.actual
###################################################
#line 2899 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.actual


###################################################
### chunk number 76: 
###################################################
#line 2907 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## clear the workspace for this example

rm(list = ls())
load("tradelist.RData")

## Set portfolios for long-short example
p.current <- portfolios[["p.current.ls"]]
p.target <- portfolios[["p.target.ls"]]

## retrieves data for the long-short portfolio
data <- data.list$data.ls

## Creates the sorts list

sorts <- list(alpha = 1, ret.1.d = 1/2)

## Original Equity, Target Equity

oe <- portfolio:::mvShort(p.current) + portfolio:::mvLong(p.current)
te <- portfolio:::mvShort(p.target) + portfolio:::mvLong(p.target)

## Creates the tradelist so we can use different measures

tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2500, sorts = sorts, turnover = 36825, target.equity = te, data =
data)

## Necessary turnover to make all the candidate trades

 nt <- mvCandidates(tl)


###################################################
### chunk number 77: prep-p.current.shares
###################################################
#line 2954 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.current.shares <- p.current@shares[, !names(p.current@shares) %in% "id"]


###################################################
### chunk number 78: 
###################################################
#line 2958 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.current.shares


###################################################
### chunk number 79: prep-p.target.shares
###################################################
#line 2966 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.target.shares <- p.target@shares[, !names(p.target@shares) %in% "id"]


###################################################
### chunk number 80: p.target.shares
###################################################
#line 2970 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
p.target.shares


###################################################
### chunk number 81: prep-sub.candidates
###################################################
#line 2985 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.candidates <- tl@candidates[,!names(tl@candidates) %in% "id"]


###################################################
### chunk number 82: sub.candidates
###################################################
#line 2989 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.candidates


###################################################
### chunk number 83: prep-restricted
###################################################
#line 3016 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
row.names(tl@restricted) <- 1:nrow(tl@restricted)


###################################################
### chunk number 84: restricted
###################################################
#line 3020 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@restricted


###################################################
### chunk number 85: 
###################################################
#line 3037 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sorts <- list(alpha = 1, ret.1.d = 1/2)


###################################################
### chunk number 86: 
###################################################
#line 3050 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
row.names(data) <- data$id
sub.data <- data[, c("id", "volume", "price.usd", "alpha", "ret.1.d")]


###################################################
### chunk number 87: necessary data
###################################################
#line 3055 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.data


###################################################
### chunk number 88: new ls tradelist
###################################################
#line 3069 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2000, sorts = sorts, turnover = 36825, data = data)



###################################################
### chunk number 89: 
###################################################
#line 3076 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl <- new("tradelist", orig = p.current, target = p.target, chunk.usd
= 2000, sorts = sorts, turnover = 36825, target.equity = te, data =
data)


###################################################
### chunk number 90: 
###################################################
#line 3114 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

ranks <- tl@rank.sorts$alpha
ranks <- split(ranks, ranks$side)
ranks$B$rank <- 1:nrow(ranks$B)
ranks$S$rank <- 1:nrow(ranks$S)
ranks$X$rank <- 1:nrow(ranks$X)
ranks



###################################################
### chunk number 91: 
###################################################
#line 3140 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tmp <- do.call(rbind, lapply(ranks, function(x) {x}))
tmp <- tmp[order(tmp$rank),]
tmp[,!names(tmp) %in% "id"]


###################################################
### chunk number 92: 
###################################################
#line 3153 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@rank.sorts[["alpha"]][,!names(tl@rank.sorts[["alpha"]]) %in% "id"]


###################################################
### chunk number 93: ls weighted ranks
###################################################
#line 3168 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
ranks <- tl@rank.sorts[["alpha"]]
ranks[["rank"]] <- ranks[["rank"]]/sorts[["alpha"]]
ranks


###################################################
### chunk number 94: 
###################################################
#line 3177 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@rank.sorts[["ret.1.d"]]


###################################################
### chunk number 95: prep-duplicates
###################################################
#line 3185 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

alpha <- tl@rank.sorts[["alpha"]]
ret.1.d <- tl@rank.sorts[["ret.1.d"]]

alpha <- alpha[,!names(alpha) %in% "alpha"]
ret.1.d <- ret.1.d[,!names(ret.1.d) %in% "ret.1.d"]

duplicates <- rbind(alpha, ret.1.d)
duplicates <- duplicates[order(duplicates$id),]
row.names(duplicates) <- 1:nrow(duplicates)



###################################################
### chunk number 96: duplicates
###################################################
#line 3199 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
duplicates


###################################################
### chunk number 97: prep-top.ranks
###################################################
#line 3206 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks <- tl@ranks


###################################################
### chunk number 98: top.ranks
###################################################
#line 3210 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
top.ranks <- aggregate(duplicates[c("rank")], by = list(id = duplicates$id), min)
tl.ranks$rank <- top.ranks$rank[match(tl.ranks$id, top.ranks$id)]
tl.ranks[order(tl.ranks$rank), !names(tl@ranks) %in% c("id", "alpha", "ret.1.d", "rank.t")]


###################################################
### chunk number 99: 
###################################################
#line 3218 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl.ranks$rank <- rank(tl.ranks$rank)
tl.ranks <- tl.ranks[, !names(tl.ranks) %in% c("id", "alpha", "ret.1.d")]

tl.ranks[order(tl.ranks$rank), !names(tl.ranks) %in% c("id", "alpha", "ret.1.d", "rank.t")]


###################################################
### chunk number 100: scaled.ranks.ls
###################################################
#line 3236 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
misc$scaled.ranks.ls


###################################################
### chunk number 101: pre.rank.t
###################################################
#line 3242 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks <- tl@ranks[order(tl@ranks$rank.t),!names(tl.ranks) %in% "id"]


###################################################
### chunk number 102: rank.t
###################################################
#line 3246 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.ranks


###################################################
### chunk number 103: prep-chunks
###################################################
#line 3258 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks <- tl@chunks[, c("side", "rank.t", "chunk.shares",
                           "chunk.mv", "tca.rank")]


###################################################
### chunk number 104: chunks
###################################################
#line 3263 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks


###################################################
### chunk number 105: prep-swaps
###################################################
#line 3280 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
swaps.sub <- tl@swaps[, c("side.enter", "tca.rank.enter", "side.exit",
                          "tca.rank.exit", "rank.gain")]


###################################################
### chunk number 106: 
###################################################
#line 3285 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
swaps.sub


###################################################
### chunk number 107: 
###################################################
#line 3316 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual <- tl@swaps.actual[, c("side.enter", "tca.rank.enter", "side.exit",
                                        "tca.rank.exit", "rank.gain")]


###################################################
### chunk number 108: 
###################################################
#line 3321 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual


###################################################
### chunk number 109: 
###################################################
#line 3329 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl.bak <- tl


###################################################
### chunk number 110: 
###################################################
#line 3333 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl@turnover <- nt - tl@chunk.usd


###################################################
### chunk number 111: 
###################################################
#line 3343 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
tl <- portfolio:::calcSwapsActual(tl)


###################################################
### chunk number 112: 
###################################################
#line 3347 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual <- tl@swaps.actual[, c("side.enter", "tca.rank.enter", "side.exit",
                                        "tca.rank.exit", "rank.gain")]


###################################################
### chunk number 113: 
###################################################
#line 3352 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.swaps.actual


###################################################
### chunk number 114: 
###################################################
#line 3356 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

## restores tl to pre-swaps value

tl <- tl.bak


###################################################
### chunk number 115: 
###################################################
#line 3370 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks.actual <- tl@chunks.actual[,!names(tl@chunks.actual)
%in% c("id", "orig", "target", "shares", "mv")]


###################################################
### chunk number 116: sub.chunks.actual
###################################################
#line 3375 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"
sub.chunks.actual


###################################################
### chunk number 117: 
###################################################
#line 3388 "d:/Rcompile/CRANpkg/local/2.12/portfolio/inst/doc/tradelist.Rnw"

tl@actual



